/*!
 * phaser-web-workers - version 0.2.1 
 * A simple Phaser plugin that allows you to easily integrate Web Workers in your game
 *
 * Azerion
 * Build at 02-07-2019
 * Released under MIT License 
 */

var __extends=this&&this.__extends||function(a,b){function c(){this.constructor=a}for(var d in b)b.hasOwnProperty(d)&&(a[d]=b[d]);a.prototype=null===b?Object.create(b):(c.prototype=b.prototype,new c)},PhaserWebWorkers;!function(PhaserWebWorkers){var WorkerPolyfill=function(){function WorkerPolyfill(a){var b=this;this.messageListeners=[],this.errorListeners=[],this.workerMessageListeners=[],this.workerErrorListeners=[],this.postMessageListeners=[],this.terminated=!1,window.bla=this;var c=new XMLHttpRequest;c.open("GET",a),c.onreadystatechange=function(){if(4===c.readyState)if(c.status>=200&&c.status<400){b.script=c.responseText,b.worker={postMessage:function(a){return b.workerPostMessage(a)},addEventListener:function(a,c){return b.workerAddEventListener(a,c)}},b.eval(b.worker,b.script);var d=b.postMessageListeners;b.postMessageListeners=[];for(var e=0;e<d.length;e++)b.runPostMessage(d[e])}else b.postError(new Error("cannot find script "+a))},c.send()}return WorkerPolyfill.prototype.eval=function(self,script){(function(){eval(script)}).call(self)},WorkerPolyfill.prototype.executeEach=function(a,b){for(var c=-1;++c<a.length;)a[c]&&b(a[c])},WorkerPolyfill.prototype.callErrorListener=function(a){return function(b){b({type:"error",error:a,message:a.message})}},WorkerPolyfill.prototype.postError=function(a){var b=this.callErrorListener(a);"function"==typeof this.onerror&&b(this.onerror),this.worker&&"function"==typeof this.worker.onerror&&b(this.worker.onerror),this.executeEach(this.errorListeners,b),this.executeEach(this.workerErrorListeners,b)},WorkerPolyfill.prototype.runPostMessage=function(a){var b=this,c=function(c){try{c({data:a})}catch(d){b.postError(d)}};this.worker&&"function"==typeof this.worker.onmessage&&c(this.worker.onmessage),this.executeEach(this.workerMessageListeners,c)},WorkerPolyfill.prototype.workerPostMessage=function(a){var b=function(b){b({data:a})};"function"==typeof this.onmessage&&b(this.onmessage),this.executeEach(this.messageListeners,b)},WorkerPolyfill.prototype.workerAddEventListener=function(a,b){"message"===a?this.workerMessageListeners.push(b):"error"===a&&this.workerErrorListeners.push(b)},WorkerPolyfill.prototype.addEventListener=function(a,b){"message"===a?this.messageListeners.push(b):"error"===a&&this.errorListeners.push(b)},WorkerPolyfill.prototype.removeEventListener=function(a,b){var c;if("message"===a)c=this.messageListeners;else{if("error"!==a)return;c=this.errorListeners}for(var d=-1;++d<c.length;){var e=c[d];if(e===b){delete c[d];break}}},WorkerPolyfill.prototype.postMessage=function(a){if("undefined"==typeof a)throw new Error("postMessage() requires an argument");if(!this.terminated)return this.script?void this.runPostMessage(a):void this.postMessageListeners.push(a)},WorkerPolyfill.prototype.terminate=function(){this.terminated=!0},WorkerPolyfill.prototype.dispatchEvent=function(a){return!0},WorkerPolyfill}();PhaserWebWorkers.WorkerPolyfill=WorkerPolyfill}(PhaserWebWorkers||(PhaserWebWorkers={}));var PhaserWebWorkers;!function(a){var b=function(){function b(b,c){var d=this;this.game=b;var e=this.game.cache.getWorker(c);null!==e&&(this.name=c,this.worker=new a.WorkerPolyfill(e),this.onMessage=new Phaser.Signal,this.onError=new Phaser.Signal,this.worker.onmessage=function(a){d.onMessage.dispatch(a)},this.worker.onerror=function(a){d.onError.dispatch(a)})}return b.prototype.postMessage=function(a,b){this.worker.postMessage(a,b)},b.prototype.destroy=function(){this.worker.terminate(),this.onMessage.dispose(),this.onError.dispose(),this.name=null,this.worker=null,this.onMessage=null,this.onError=null},b}();a.PseudoWorker=b}(PhaserWebWorkers||(PhaserWebWorkers={}));var PhaserWebWorkers;!function(a){var b=function(){function a(a,b){var c=this;this.game=a;var d=this.game.cache.getWorker(b);null!==d&&(this.name=b,this.worker=new Worker(d),this.onMessage=new Phaser.Signal,this.onError=new Phaser.Signal,this.worker.onmessage=function(a){c.onMessage.dispatch(a)},this.worker.onerror=function(a){c.onError.dispatch(a)})}return a.prototype.postMessage=function(a,b){this.worker.postMessage(a,b)},a.prototype.destroy=function(){this.worker.terminate(),this.onMessage.dispose(),this.onError.dispose(),this.name=null,this.worker=null,this.onMessage=null,this.onError=null},a}();a.WebWorker=b}(PhaserWebWorkers||(PhaserWebWorkers={}));var PhaserWebWorkers;!function(a){var b=function(b){function c(a,c,d,e){var f=b.call(this,a,c)||this;return f.addWorkerLoader(),f.addWorkerFactory(),f.addWorkerCache(),f}return __extends(c,b),c.prototype.addWorkerLoader=function(){Phaser.Loader.prototype.worker=function(a,b,c,d){var e=this;return void 0===c&&(c=!1),c!==!1&&void 0===d&&(d=this),this.addToFileList("script",a,b,{syncPoint:!0,callback:function(a,b){var c=new Blob([b],{type:"javascript/worker"});e.game.cache.addWorker(a,window.URL.createObjectURL(c))},callbackContext:d},!1,".js")}},c.prototype.addWorkerFactory=function(){Phaser.GameObjectFactory.prototype.worker=function(b,c){return void 0===c&&(c=!1),c?new a.PseudoWorker(this.game,b):new a.WebWorker(this.game,b)},Phaser.GameObjectCreator.prototype.worker=function(b,c){return void 0===c&&(c=!1),c?new a.PseudoWorker(this.game,b):new a.WebWorker(this.game,b)}},c.prototype.addWorkerCache=function(){Phaser.Cache.prototype._workers={},Phaser.Cache.prototype.addWorker=function(a,b){this._workers[a]=b},Phaser.Cache.prototype.removeWorker=function(a){this._workers.hasOwnProperty(a)&&(window.URL.revokeObjectURL(this._workers[a]),delete this._workers[a])},Phaser.Cache.prototype.getWorker=function(a){if(this._workers.hasOwnProperty(a))return this._workers[a]}},c}(Phaser.Plugin);a.Plugin=b}(PhaserWebWorkers||(PhaserWebWorkers={}));